package example.energy;

import schedframe.resources.computing.Node;
import schedframe.resources.computing.DataCenter;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.resources.computing.profiles.energy.power.PowerUsage;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;

public class DataCenterEnergyEstimationPlugin extends BaseEnergyEstimationPlugin{

	@Override
	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		double power = 0;
		DataCenter dataCenter = (DataCenter)resource;
		for(Node cn: dataCenter.getNodes()){
			PowerUsage powerUsage = cn.getPowerInterface().getRecentPowerUsage();
			power += (powerUsage == null ? 0 : powerUsage.getValue());
		}

		return power;
	}

}
